diff options
author | Filipe Brandenburger <filbranden@google.com> | 2018-03-05 08:03:52 -0800 |
---|---|---|
committer | Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> | 2018-03-05 17:03:52 +0100 |
commit | 2ea09665e2064df725d2a2f18f24bac29fbee2c2 (patch) | |
tree | edae08d1f6e7bdd443cb216bb750201cdadd9c47 | |
parent | 81818edc7acf6de3e496c5193d5d32dfb022fef9 (diff) | |
download | systemd-2ea09665e2064df725d2a2f18f24bac29fbee2c2.tar.gz |
mkosi: use locale that supports UTF-8, detect one that is available (#8340)
Using C.UTF-8 (as was done before #7244) breaks Arch Linux, but using
en_US.UTF-8 (after #7244) breaks Debian in our .mkosi/mkosi.debian.
So try to detect which one is available and works, first checking
whether we're already running under a valid UTF-8 locale, then trying
C.UTF-8 and finally en_US.UTF-8.
If we fail to find a valid UTF-8 locale, then fail early, instead of
letting the whole build complete only for Mesos to fail midway through
the `ninja test` step.
Tested on all of mkosi.fedora, mkosi.debian and mkosi.arch.
Fixes: #7238
-rwxr-xr-x | mkosi.build | 23 |
1 files changed, 22 insertions, 1 deletions
diff --git a/mkosi.build b/mkosi.build index 0e644d54cb..7cdcd6c741 100755 --- a/mkosi.build +++ b/mkosi.build @@ -25,7 +25,28 @@ set -ex # as out-of-tree build dir. Otherwise, let's make up our own builddir. [ -z "$BUILDDIR" ] && BUILDDIR=build -export LC_CTYPE=en_US.UTF-8 +# Meson uses Python 3 and requires a locale with an UTF-8 character map. +# Not running under UTF-8 makes the `ninja test` step break with a CodecError. +# So let's ensure we're running under UTF-8. +# +# If our current locale already is UTF-8, then we don't need to do anything: +if [ "$(locale charmap)" != "UTF-8" ] ; then + # Try using C.UTF-8 locale, if available. This locale is not shipped + # by upstream glibc, so it's not available in all distros. + # (In particular, it's not available in Arch Linux.) + export LC_CTYPE=C.UTF-8 + if [ "$(locale charmap)" != "UTF-8" ] ; then + # Finally, try something like en_US.UTF-8, which should be + # available in Arch Linux, but is not present in Debian's + # minimal image in our mkosi config. + export LC_CTYPE=en_US.UTF-8 + if [ "$(locale charmap)" != "UTF-8" ] ; then + # If nothing works, fail early. + echo "*** Could not find a valid locale that supports UTF-8. ***" >&2 + exit 1 + fi + fi +fi if [ ! -f "$BUILDDIR"/build.ninja ] ; then sysvinit_path=`realpath /etc/init.d` |